package com.sagacloud.route.processors.Insurance;
/*
 * Author: Jxing
 * Create Time: 2018/7/12
 */

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.Exceptions.InvalidPostException;
import com.sagacloud.pojos.DPSelectPropertyResult;
import com.sagacloud.pojos.Warranty;
import com.sagacloud.utils.Const;
import com.sagacloud.utils.VendersUtil;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

public class GetPropertyUnderWarrantyProcessor implements Processor {
    public static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    @Override
    public void process(Exchange exchange) throws Exception {
        String jsonStr = exchange.getIn().getBody(String.class);
        DPSelectPropertyResult dpResult = JSONObject.parseObject(jsonStr, DPSelectPropertyResult.class);
        System.out.println(jsonStr);
        if(dpResult.getResult() == null && !dpResult.getResult().equals("success"))
            throw new InvalidPostException("数据平台返回异常!");

        HashSet<String> validWarranty = new HashSet<>();
        List<Warranty> ws = (List<Warranty>) exchange.getProperty("warrantyList");
        List<Map<String, Object>> propertyList = dpResult.getContent();
        //
        for(int i = 0; i < ws.size(); ++i){
            Warranty warrnaty = ws.get(i);
            try {
                Date expireDate = sdf.parse(warrnaty.getExpireDate());
                Date now = new Date();
                if(now.compareTo(expireDate) <= 0 && !validWarranty.contains(warrnaty.getInsuranceNo()))
                    validWarranty.add(warrnaty.getInsuranceNo());
            }catch (Exception ignore)
            {}
        }
        if(validWarranty.size() == 0 || propertyList.size() == 0)
        {
            exchange.getOut().setBody(VendersUtil.successJsonMsg("", new JSONArray()));
            return;
        }

        for(int i = propertyList.size() - 1; i > -1; --i){
            Map<String, Object> property = propertyList.get(i);
            Map<String, Object> infos = (Map<String, Object>) property.get("infos");
            if(infos.get(Const.INFO_INSURANCENUM) == null || !validWarranty.contains(infos.get(Const.INFO_INSURANCENUM).toString().trim())){
                propertyList.remove(i);
            }
        }
        exchange.getOut().setBody(VendersUtil.successJsonMsg("", (JSONArray) JSONArray.toJSON(propertyList)));
    }
}
